#ifndef _INTERFACE_H_
#define _INTERFACE_H_

#include "commdef.h"


#ifdef _WIN32
class ARCLIB_API ArcInterface
#else
class ArcInterface
#endif
{
public:	
	virtual ~ArcInterface()
	{
	}
	virtual int send(const char *outBuf, int outLen) = 0;	
	virtual int recv(char *inBuf, int inLen) = 0;
	virtual int syncSend(const char *outBuf, int outLen, char *inBuf, int inLen) = 0;

	// These two member functions will be called by the syncSend() member function
	// to ensure the synchronization of send() and recv() to the single controller.
	// The requirelock() will be called before the send() called, 
	// and releaselock() will be called after the recv() called.
	virtual void requirelock(){}
	virtual void releaselock(){}
};


#endif
